//=======================================================================================
// Copyright Nuvoton(SH) Technology Corp. All rights reserved. 2015/05/01   
//=======================================================================================
#define   Mini5xxDE_GLOBAL        
#include  "Mini5D_BLDC_v1.h"   
#include  "BLDC_Hall.h" 

uint32_t            PeriodMax = 200*1000 ; 
//uint32_t *volatile  pPhaseCur ;          // Hall࣬ȥļBLDC_Hall.libϴ˱

#define   ACMP_PH_A                CMP1_PIN_P32            // AӦıȽ
#define   ACMP_PH_B                CMP1_PIN_P34             
#define   ACMP_PH_C                CMP1_PIN_P35     
#define   DETEC_UP                 0x8000                  // ҲԶ 0x4000
 
#define   PWM1_OUT_EN              0                       // PWM1  A- 
//#define   PWM1_OUT_EN              0x0200                // PWM1 ѹ, 220V BLDC

///// A-ɶPIN /////////////////////////////////////////////////////////////////
// PWM024 PWM, MOS ͨ, PWM135ź, MOS ͨ 
#define   PHASE_AB        PWM1_OUT_EN | (0x01E2ul)              
#define   PHASE_AC        PWM1_OUT_EN | (0x01CAul)                    
#define   PHASE_BC        PWM1_OUT_EN | (0x04CAul)                      
#define   PHASE_BA        PWM1_OUT_EN | (0x04E8ul&(~0xC0)) // D6,D7  A- ź                     
#define   PHASE_CA        PWM1_OUT_EN | (0x10E8ul&(~0xC0))           
#define   PHASE_CB        PWM1_OUT_EN | (0x10E2ul)                     

#define   PHASE_AB_                (0x03E2ul)               
#define   PHASE_AC_                (0x03CAul)            
#define   PHASE_BC_                (0x0CCAul)                          
#define   PHASE_BA_                (0x0CE8ul&(~0xC0))      // A-ҲɽD6D7,AͲǻ                         
#define   PHASE_CA_                (0x30E8ul&(~0xC0))                               
#define   PHASE_CB_                (0x30E2ul)      
/////////////////////////////////////////////////////////////////////////////////////////
uint32_t TabPhase[25] = {                        
    T0_TRG_PWM_EN | PHASE_CB  | ACMP_PH_A | DETEC_UP , 
  
    T0_TRG_PWM_EN | PHASE_AB  | ACMP_PH_C ,               
    T0_TRG_PWM_EN | PHASE_AC  | ACMP_PH_B | DETEC_UP ,   
    T0_TRG_PWM_EN | PHASE_BC  | ACMP_PH_A ,            
    T0_TRG_PWM_EN | PHASE_BA  | ACMP_PH_C | DETEC_UP , 
    T0_TRG_PWM_EN | PHASE_CA  | ACMP_PH_B ,             
    T0_TRG_PWM_EN | PHASE_CB  | ACMP_PH_A | DETEC_UP ,   
  
    T0_TRG_PWM_EN | PHASE_AB_ | ACMP_PH_C ,               
    T0_TRG_PWM_EN | PHASE_AC_ | ACMP_PH_B | DETEC_UP ,   
    T0_TRG_PWM_EN | PHASE_BC_ | ACMP_PH_A ,            
    T0_TRG_PWM_EN | PHASE_BA_ | ACMP_PH_C | DETEC_UP , 
    T0_TRG_PWM_EN | PHASE_CA_ | ACMP_PH_B ,             
    T0_TRG_PWM_EN | PHASE_CB_ | ACMP_PH_A | DETEC_UP , 
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x11E2ul),         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x01C2ul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x05CAul),           
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x04C8ul&(~0xC0)),  
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x14E8ul&(~0xC0)),  
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x10E0ul&(~0xC0)),         
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x33E2ul),         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x03C2ul),         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0FCAul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0CC8ul&(~0xC0)), 
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x3CE8ul&(~0xC0)), 
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x30E0ul&(~0xC0)),        
};    

/////////////////////////////////////////////////////////////////////////////////////////
uint32_t TabPhaseRev[25] = {                        
    T0_TRG_PWM_EN | PHASE_BC  | ACMP_PH_A | DETEC_UP ,  
  
    T0_TRG_PWM_EN | PHASE_AC  | ACMP_PH_B ,   
    T0_TRG_PWM_EN | PHASE_AB  | ACMP_PH_C | DETEC_UP ,    
    T0_TRG_PWM_EN | PHASE_CB  | ACMP_PH_A ,      
    T0_TRG_PWM_EN | PHASE_CA  | ACMP_PH_B | DETEC_UP ,         
    T0_TRG_PWM_EN | PHASE_BA  | ACMP_PH_C ,                    
    T0_TRG_PWM_EN | PHASE_BC  | ACMP_PH_A | DETEC_UP ,   
  
    T0_TRG_PWM_EN | PHASE_AC_ | ACMP_PH_B ,   
    T0_TRG_PWM_EN | PHASE_AB_ | ACMP_PH_C | DETEC_UP ,    
    T0_TRG_PWM_EN | PHASE_CB_ | ACMP_PH_A ,      
    T0_TRG_PWM_EN | PHASE_CA_ | ACMP_PH_B | DETEC_UP ,               
    T0_TRG_PWM_EN | PHASE_BA_ | ACMP_PH_C , 
    T0_TRG_PWM_EN | PHASE_BC_ | ACMP_PH_A | DETEC_UP ,  
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x05CAul),         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x01C2ul),          
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x11E2ul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x10E0ul&(~0xC0)),       
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x14E8ul&(~0xC0)), 
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x04C8ul&(~0xC0)),  
                                                         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0FCAul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x03C2ul),         
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x33E2ul),        
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x30E0ul&(~0xC0)),    
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x3CE8ul&(~0xC0)), 
    T0_TRG_PWM_EN | PWM1_OUT_EN | (0x0CC8ul&(~0xC0)),  
};    

uint32_t  DetectUpBit  = 0x8000   ;    
uint32_t  AcmpOutBit   = ACMP_OUT1 ;   
uint32_t  Shut_All_MOS = 0xEA | PWM1_OUT_EN ;              // дPHCHGض·MOS  
//=======================================================================================
void Delayus(uint32_t Time)                                // 16777215(Լ16)
{
  uint32_t T1 = TIMER1->DR ; 
  while(((TIMER1->DR - T1) & 0xFFFFFF) < Time) ;         
}
void PWM024_0_MOS_On(void)                                 
{
  uint32_t n ;
  PWM->PCR ^= (PCR_INV_EN(0)|PCR_INV_EN(2)|PCR_INV_EN(4)) ;          
  for(n=0; n<25; ++n){TabPhase[n] ^= 0x15; TabPhaseRev[n] ^= 0x15; } 
  Shut_All_MOS ^= 0x15 ;                                            
}
void PWM135_1_MOS_On(void)                                
{
  uint32_t n ;
  PWM->PCR ^= (PCR_INV_EN(1)|PCR_INV_EN(3)|PCR_INV_EN(5)) ;         
  for(n=0; n<25; ++n){TabPhase[n] ^= 0x6A; TabPhaseRev[n] ^= 0x6A; }   
  Shut_All_MOS ^= 0x6A ;
}
#define  BRK1_SOURCE_CPO0      0x04 
void PWM_ACMP0_T0_T1_Init(void) 
{
  TIMER0->CSR   =  T_CRST | T_MODE_PERIODIC | T_WR_TCMP_NO_RST | T_TDR_EN + 21 ;  
  TIMER1->CSR   =  T_CRST | T_MODE_CONTINUOUS | T_TDR_EN + 21 ;                // 22 Ƶ
  TIMER1->CSR  |=  T_CEN ;                                 // Timer1 ʼ
  NVIC_SetPriority(TMR1_IRQn, 1) ;                          
  NVIC->ISER[0] = 1<<TMR1_IRQn ;                           // Timer1ͿDelayus()

  ACMP->SR       = ~0 ;  
  ACMP->CR0      =  ACMP_CPP0_P10 | ACMP_EN ;	           // P1.0 
  ACMP->CR1      =  ACMP_EN ; 
  PWM->PHCHGMASK = PHCHG_CTL_CMP1 | P00_OUT_D7 ;          
	
  PWM->PPR = PPR_DIV45(2)   | PPR_DIV23(2)    | PPR_DIV01(2) ;     // PWM clk divide by 2
  PWM->CSR = CSR_DIV1_CH(5) | CSR_DIV1_CH(4)  | CSR_DIV1_CH(3)     // CSR, no divide
           | CSR_DIV1_CH(2) | CSR_DIV1_CH(1)  | CSR_DIV1_CH(0) ;                    
  PWM->PCR = PCR_GROUP_MODE | PCR_CLR_COUNTER | PCR_DEBUG_MODE        
     | PCR_COMPLE | PCR_DZEN45_EN | PCR_DZEN23_EN | PCR_DZEN01_EN  //  PWM1 ѹ,ȥ
     | PCR_CH_EN(5) | PCR_PERIOD_MODE(5) | PCR_INV_EN(1) | PCR_CH_EN(4) | PCR_PERIOD_MODE(4) 
     | PCR_CH_EN(3) | PCR_PERIOD_MODE(3) | PCR_INV_EN(3) | PCR_CH_EN(2) | PCR_PERIOD_MODE(2) 
     | PCR_CH_EN(1) | PCR_PERIOD_MODE(1) | PCR_INV_EN(5) | PCR_CH_EN(0) | PCR_PERIOD_MODE(0);   
  PWM->CMR0  = 0 ;                                        
  PWM->CMR1  = 0 ;                                  
  PWM->PDZIR = 0x111111 ;                                // ʱ 18 PWM CLK,Լ1.6us

//  DetectUpBit = DETEC_UP ;
//  AcmpOutBit  = ACMP_OUT1 ;                                // ACMP1  
//  PWM024_0_MOS_On() ;                 // PWM024 ʱ MOS ͨ,ô˺     
//  PWM135_1_MOS_On() ;                 // PWM135 ʱ MOS ͨ,ô˺ 
   
  if(Shut_All_MOS & 0x20) GPIO0->DOUT = 0xFC ;             // D5_P0.4 ض MOS
  else GPIO0->DOUT = 0xEC ;                                
  if(Shut_All_MOS & 0x40) GPIO0->DOUT |= 0x02 ;            // D6_P0.1 ض MOS
  if(Shut_All_MOS & 0x80) GPIO0->DOUT |= 0x01 ;            // D7_P0.0 ض MOS
  GPIO2->DOUT     = Shut_All_MOS << 2 ;                    
  PWM->PHCHGNXT   = Shut_All_MOS ;                         
  PWM->PHCHG      = Shut_All_MOS ;                  
  PWM->TRGCON0    = 0x0008 ;                               // 0 㴥 ADC 
  PWM->PIIR       = ~0 ;  
//  PWM->PFBCON     = (Shut_All_MOS<<24) | BRK1_SOURCE_CPO0 | BRK1_EN;  //INT1(ACMP0) break 
  PWM->PIER       = PIER_BRKE_IE + PIER_PIE(0);            // BRKIE  PWM0 жʹ
  PWM->INTACCUCTL = 0 ;                               
  PWM->POE        = 0x3F ;                                 // Enable PWM output
  
  NVIC_SetPriority(FB_IRQn, 0) ;                           // Brake ж 
  NVIC->ISER[0]  = 1 << FB_IRQn ;                        
  NVIC_SetPriority(PWM_IRQn, 0) ;                        
  NVIC->ISER[0] = 1 << PWM_IRQn ;   
	
  pPhaseEnd = &TabPhase[6] ;                               // ȸתֵ
  pPhase    = &TabPhase[1] ;                               // ÷, õЩֵ
}

void BLDC_STOP(void)                                       // عʹ,ͣת
{                                       
  NVIC->ICER[0] = 1<<GPIO01_IRQn ;		                   // Ͽ Hall ж	
  TIMER0->CSR  &= ~T_IE ;                                  // سʱʱж
  TIMER1->CSR  &= ~T_IE ;                                  // ֹͣжPHCHGNXT
  PWM->PHCHGNXT =  Shut_All_MOS ;                          //  MOSFET
  PWM->PHCHG    =  Shut_All_MOS ;   
  gFlag        &= ~Flag_BRAKE_ING ;	
//  PeriodNow     = 11000000 ;                               // תΪ0  
  Delayus(10) ;                                            //  MOS ȫض
}

//=======================================================================================   
////  BLDC_STOP()ֹͣɲ, תǰȹ· MOS ///////////////////////////////////
void BLDC_Brake()                     
{
  BLDC_STOP() ;                                            // ͣ
  PWM->PHCHG = Shut_All_MOS ^0x6A ;                        // PWM135D6,D7ȫͨ 
}
void Motor_Beep(uint32_t Duration, uint32_t Period) //ʱͰ(൱),΢
{
  uint32_t temp32 = TIMER1->DR ;  
    
  if(pPhase > (pPhaseEnd-3)) pPhase = pPhaseEnd-5 ;         
  Duty_Current = 10*PWM_one_percent ;                      
  PWM->CMR0    = Duty_Current ;                     
  do{
    PWM->PHCHG = *(pPhase+3) & (~T0_TRG_PWM_EN) ;    
    Delayus(Period) ;  BLDC_STOP() ;
    PWM->PHCHG = *pPhase & (~T0_TRG_PWM_EN) ;          
    Delayus(Period) ; BLDC_STOP() ; 
  }while(((TIMER1->DR - temp32) & 0xFFFFFF) < (Duration<<1)) ; 
  Delayus(1000) ; 
}
void FB_IRQHandler(void)                               
{                                 
  GCR->P2_MFP     = 0;                                           // ض MOS
  GCR->P0_MFP    &= ~0x1010; 
  PWM->PHCHGMASK &= ~(P01_OUT_D6 | P00_OUT_D7);
  ACMP_Flag      |= ACMP_EVER_SHORT ;           
                                              //  LED_TOGGLE() ;
  ACMP->SR     = ACMP_CF1 | ACMP_CF0 ;                           // жϱ־ 
  PWM->PIIR    = ~0 ;                          
  PWM->PFBCON |= 0x80 ;                                        
  PWM->PCR    |= PCR_CH_EN(5) | PCR_CH_EN(4) | PCR_CH_EN(3)      // ʹ PWM
               | PCR_CH_EN(2) | PCR_CH_EN(1) | PCR_CH_EN(0) ;
}
////=====================================================================================
////                            ϴ,Ķ
////=====================================================================================
// ȼִƵ,ִʱ䲻̫,,ɹص FB  PWM жԽʡCPUʱ 
//  PWM ж, ںBLDC_control(),д PWM->CMR0 ,ѹ
void PWM_IRQHandler(void)                                
{  
  GCR->P2_MFP     = 0x7C00 ;                                     // MOS  PHCHG  
  GCR->P0_MFP    |= 0x1010 ; 
  PWM->PHCHGMASK |= P00_OUT_D7 ;     
  PWM->CMR0       = Duty_Current ;                                            
  PWM->PIIR       = ~0 ;                                         // жϱ־ 
} 

////=====================================================================================
const uint8_t Tabel_H[8] = {0,1,5,6,3,2,4,0} ;                   // ,Ҳ{0,4,2,3,6,5,1,0}
__weak void  BLDC_Hall_Init(void)                      
{  
  StepCount      =  0 ;    
  TickSingleHall = *pTimer ;    
}
__weak uint32_t* Get_pPhaseCur_Next(uint32_t x)
{
  uint32_t* ptr = pPhaseCur ; 
    
  if(x){ 
    if(++ptr > (pPhaseStart + 6)) ptr -= 6;                      // ָһ
  } 
  return ptr ;
}
__weak uint32_t Updata_pPhaseCur_From_Hall(uint32_t Hall_Data, uint32_t Reverse) 
{
  uint32_t temp32 = Hall_Data & 7 ; 
  
  if(Reverse) temp32 = Tabel_H[temp32^7] ;        
  else        temp32 = Tabel_H[temp32] ;                                                                        
  pPhaseCur = pPhaseStart + temp32 ;                             // һ     
  return 0 ;
}

void GPIO01_IRQHandler(void)
{	  
  uint32_t temp32, Tim = TIMER1->DR ;  
  
  do{
    temp32 = GPIO0->PIN & 0x00E0 ;                               //  Hall ֵ
    Delayus(1);	
    if(temp32 != (GPIO0->PIN & 0x00E0)) continue ;	  
    Delayus(1);	
    if(temp32 == (GPIO0->PIN & 0x00E0)) break ;	  
  }while(((TIMER1->DR - Tim) & 0xFFFFFF) > 30) ; 	
  temp32 = (GPIO0->ISR << 16) | temp32 ;   
  temp32 = ((temp32 >> 4) & 0x60006) | ((temp32 >> 7) & 0x10001) ; 
  
  temp32 = Updata_pPhaseCur_From_Hall(temp32, gFlag & Flag_REVERSE); //  Hall 
  if(temp32 & 0x08) Get_pPhaseCur_Next(1) ;                          // ȫ0, pPhaseCur1   

  if(temp32 & 0x40){PWM->PHCHG = Shut_All_MOS;  Delayus(3); }
  PWM->PHCHG = *pPhaseCur & (~T0_TRG_PWM_EN);                    // , ȥԶ๦

  TIMER0->CSR |= T_CRST | T_IE ;                                 // λʱ    
  if(temp32 & 0x07) TIMER0->CMPR = ((PeriodHall*40)>>8);         // 6,´Hallź,ʱ=ʱ            
  else TIMER0->CMPR = (PeriodHall>>2);                           // ´Hallź,ʱ=*6/4
  TIMER0->CSR |= T_CEN ;                                         // ʱ
  
  if(++StepCount > 20) if(Duty_Target > Duty_Current) ++Duty_Current ;
  HallTick = TIMER1->DR ;
                                                                                                 
  GPIO0->ISR = ~0 ;           
}

void TMR0_IRQHandler(void)                                
{
  Get_pPhaseCur_Next(1) ;                                        //  pPhaseCur ָһ
  PWM->PHCHG   = *pPhaseCur & (~T0_TRG_PWM_EN);                  //   
  TIMER0->CMPR = PeriodHall >> 2 ;                               // ʱʱӳ Hall ź
  TIMER0->ISR  = ~0 ;             
}
