//=======================================================================================
// Copyright Nuvoton(SH) Technology Corp. All rights reserved. 2015/01/01   
//=======================================================================================
#ifndef  __Mini5xxDE_BLDC_H        
#define  __Mini5xxDE_BLDC_H             
#include  "Mini5xxDE.h"       
 
#ifndef  Mini5xxDE_GLOBAL            
 #define  EXT_BLDC  extern                      
#else  
 #define EXT_BLDC         
#endif

#define  LED_LIGHT()         (GPIO52 = 0)   
#define  LED_DARK()          (GPIO52 = 1)
#define  LED_TOGGLE()        (GPIO5->DOUT ^= 0x04)    

#define  ADC0_MOTOR_TEMP           0x01          // ¶, ¶
#define  ADC1_VIN                  0x02          // ѹ 
#define  ADC2_CURRENT              0x04          // ƽ  
#define  ADC3_SPEED                0x08          // ٶ 
#define  ADC7_PCB_TEMP             0x80          // PCB ¶
 
EXT_BLDC volatile uint32_t gFlag ;   
#define  Flag_VOLTAGE_LOW          0x0001        // ѹ̫
#define  Flag_PCB_TEMP_OV          0x0002        // PCB 
#define  Flag_MOT_TEMP_OV          0x0004        // 

#define  Flag_WITHOUT_HALL         0x0020        // ޻ת
#define  Flag_REVERSE              0x0040        // ת
#define  Flag_STOP                 0x0080 

#define  Flag_BRAKE                0x0100
#define  Flag_BRAKE_ING            0x0200
#define  Flag_HEANY                0x0400

EXT_BLDC  uint32_t Hall_Mode, Add_Phase ; 
EXT_BLDC  uint32_t ACMP_Flag ; 
#define  ACMP_EVER_SHORT           0x0001        // ACMP 쵽·

EXT_BLDC uint32_t *volatile  pPhase ;             // ָ    

EXT_BLDC uint32_t         *pPhaseEnd ;
EXT_BLDC uint32_t          PWM_one_percent ;     // 1%ֵ
EXT_BLDC uint32_t          Duty_Min  ;           // Сռձ, 0 ~ CNR
EXT_BLDC uint32_t          Duty_Current ;        // ǰѹռձ 
EXT_BLDC uint32_t          Duty_Target ;         // ռձĿֵ

EXT_BLDC  int32_t          Adc_Current ;         // ֵ  
EXT_BLDC uint32_t          Current_Limit ;       // ֵ 
EXT_BLDC uint32_t          Current_Zero  ;       // 0ʱ ADC ֵ
EXT_BLDC uint32_t volatile HallTick ;            // Hall ʱ
EXT_BLDC uint32_t          CurOneStep ; 

EXT_BLDC uint32_t          Delay_Length ;        // ʱʱ
EXT_BLDC uint32_t volatile TickRelay ;           // ÿ SysTick жϼ1

void  PWM_ACMP0_T0_T1_Init(void) ;               // T0,T1,PWM ʱӶѡ HCLK = 22M  
void  BLDC_STOP(void) ;                          // ֹͣ BLDC,ͣ
void  BLDC_Brake(void) ;                         // ɲ
void  Motor_Beep(uint32_t Duration, uint32_t Period) ;

void  Delayus(uint32_t Time) ;                   // 24λ,  16s (1MHz)

#endif   // __Mini5xxDE_BLDC_H 
