//=======================================================================================
// Copyright Nuvoton(SH) Technology Corp. All rights reserved. 2015/05/01   
//=======================================================================================
// ʱ׼ Timer0/1 ʱӶ 22.1184M/11 = 2MHz,  2000 Ϊ 1ms 
#include  "Mini5D_BLDC_V1.h"                
#include  "BLDC_Hall.h"  

//uint32_t *volatile  pPhaseCur ; 
                                                         
#define  VIN_MIN_L           ((135*437)>>7)                // 20K/100K ѹ
#define  VIN_MIN_LL          ((120*437)>>7)      

#define  TEMP_MOT_HH         (1024*6 /(6+47))              // 110 ʱֵ 0.7K
#define  TEMP_MOT_H          (1024*10/(10+47))             // 97 ʱֵ 1.0K
#define  TEMP_PCB_HH         (1024*6 /(6+47))              // 110 ʱֵ 0.7K
#define  TEMP_PCB_H          (1024*10/(10+47))             // 97 ʱֵ 1.0K

#define  LED1_LIGHT()        (GPIO36 = 1) 
#define  LED1_DARK()         (GPIO36 = 0)  
#define  LED2_LIGHT()        (GPIO51 = 1) 
#define  LED2_DARK()         (GPIO51 = 0) 
#define  LED3_LIGHT()        (GPIO50 = 1) 
#define  LED3_DARK()         (GPIO50 = 0) 

#define  POWER_ON()          (GPIO01 = 1)
#define  POWER_OFF()         (GPIO01 = 0)
#define  CUR_RES                   5                       // ,ŷ

extern uint32_t TabPhase[25] ;

typedef struct{
    uint32_t Duty ;          // ռձϵ
    uint32_t CurHeavy ;      // ص
    uint32_t CurDrop ;       // ص
    uint32_t Delay ;         // Dutyʱ
	uint32_t volatile *LED ;
}Type_RANK ;
Type_RANK SpeedRank[3] = {                                 // λ
    {72, 6<<4,  2<<4, 500*1000, &GPIO36},   // 8.7
    {83, 8<<4,  4<<4, 400*1000, &GPIO51},   //12.8, A*(CUR_RES*1024/5000) = 
    {128,11<<4, 6<<4, 300*1000, &GPIO50},   //16.7
};

uint32_t  volatile  Duty_Command = 8*8 ;                   // Duty, Χ 0 ~ CNR
uint32_t  SpeedLevel, *LimitSpeed = (uint32_t *)0x1FF0 ; 
uint32_t *pPhaseStart ;
uint32_t  volatile *pTimer ;           // ָģʽ2ƶʱ,ɶʱ, TIMER1->DR
uint32_t  volatile  Hall_Status,PeriodHall ;
uint32_t  volatile  StepCount ; 
////=====================================================================================             
void UnlockReg(void)   
{
  while((GCR->RegLockAddr & 1) == 0){                      // ֹϽɹ
    GCR->RegLockAddr = 0x59 ; 
    GCR->RegLockAddr = 0x16 ;  
    GCR->RegLockAddr = 0x88 ;  
  }
} 
void SystemInit(void)       
{
  UnlockReg();   
    CLK->PWRCON  = 0x001C ; 
    CLK->CLKDIV  = ADC_CLK_DIV_8bit(3) ;                   // ADC ʱ 22M/3 = 7M
    CLK->CLKSEL0 = CLKS0_HCLK_22M_ | CLKS0_TICK_HCLK_DIV2_ ; 
    CLK->CLKSEL1 = CLKS1_PWM23_HCLK | CLKS1_PWM01_HCLK | CLKS1_UART_22M | CLKS1_TMR1_HCLK 
                 | CLKS1_TMR0_HCLK  | CLKS1_ADC_22M    | CLKS1_WDT_10K_ | CLKS1_SPI_22M ;
    CLK->CLKSEL2 = CLKS2_PWM45_HCLK ;
    CLK->APBCLK  = CLK_ADC_EN | CLK_PWM45_EN | CLK_PWM23_EN | CLK_PWM01_EN | CLK_UART_EN           
                 | CLK_TMR1_EN | CLK_TMR0_EN | CLK_ACMP_EN  | CLK_SPI_EN   |CLK_WDT_EN ; 

  
  SysTick->VAL   = 50*11000 ;			                           
  SysTick->LOAD  = 50*11000 ;                             // Period = 0.1S, CLK=22Mhz/2
  SCB->SHP[1]    = ~0 ;                                    // Interrupt priority = 3 
  SysTick->CTRL  = 0x0003 ;                                // IE & EN
}
////UART0 Initial ///////////////////////////////////////////////////////////////////////
void UART0_Init(uint32_t Baud)                 
{
  UART0->FUN_SEL = 0  ;                                    //UART ģʽ
  UART0->LCR     = 0x0007 ;                                //8bit, 2-stop, no parity
  UART0->BAUD    = 0x30000000 + 22118400/Baud - 2 ;        //UART ʱ 22M
  UART0->FCR     = 0x00020020 ;                            //RTS trigger:8, FIFO trigger:8 BYTE
  UART0->IER     = 0 ;                                   
}
/////////////////////////////////////////////////////////////////////////////////////////
// Configure P2.23456 & P0.4 as PWM function pin.  configure P1.0345 as ACMP input pin
void GPIO_Init(void) 
{     
  // GPIO0->DOUT ʼ PWM ʼ    // P0.1óOUTģʽ,PHCHG,QBģʽ                                                              
  GPIO0->PMD  = Px7_QB | Px6_QB | Px5_QB | Px1_OUT | Px0_QB ;  // P0.014567,        
  GCR->P0_MFP = 0x1010 ;                                   // P0.4_PWM5
                            
  GPIO1->PMD  = 0 ;                                        // P1.02345,
  GPIO1->OFFD = 0x00FF0000 ;  
  GPIO1->DMASK= 0xFF ;                                     // ȫ ADC 
  GCR->P1_MFP = 0x303F ;                                   // P1.45_ACMP0, P1.023_ADC
    
  // GPIO2->DOUTʼ PWM ʼ
  GCR->P2_MFP = 0x7C00 ;                                   // P2.23456 ,PWM01234

  GPIO3->DOUT = 0xBF ;                                     // P3.012456 
  GPIO3->PMD  = Px6_OUT  ;                                   
  GPIO3->OFFD = 0x00FF0000 ;  
  GPIO3->DMASK= 0x3F ;
  GCR->P3_MFP = 0x01003332 ;                               // P3.0245_ACMP1, P3.1_AIN7

  GPIO4->DOUT = 0xFF ;
  GPIO4->PMD  = Px7_QB | Px6_QB ;                          // P4.67,ICEӿ
  GCR->P4_MFP = 0 ;                                

  GPIO5->DOUT = 0xFC ;                                     // P5.012345 ,(QFN33ûP5.5)
  GPIO5->PMD  = Px5_QB | Px4_QB | Px2_OUT | Px1_OUT | Px0_OUT ;   
  GCR->P5_MFP = 0x0008 ;                                   // P5.3_ADC0,P55_KEY
  
  GPIODBNCE   = 0x26 ;					                   // De-bounce = 64 HCLK
  GPIO0->DBEN = 0xE0 ;                                     // Enable De-bounce
  GPIO0->IMD  = 0x00 ;                                     // Edge interrupt mode
  GPIO0->ISR  = ~0 ;                                       // ־ʹж֮ǰ
  GPIO0->IER  = 0xE000E0 ;                                 // λ0~7жʹ,16~23ʹ
  NVIC_SetPriority(GPIO01_IRQn, 0) ;                        //Interrupt priority = 0 
//  NVIC->ISER[0] = 1<<GPIO01_IRQn ;		 		
  
  GPIO5->DBEN = 0x20 ;                                     // P55 Enable De-bounce
  GPIO5->IMD  = 0 ;                                        // Edge interrupt mode
  GPIO5->ISR  = ~0 ;                                       // Clear ISR  
  GPIO5->IER  = 0x20 ;                                     // ʹٰܵж   
  NVIC_SetPriority(GPIO5_IRQn, 2) ;                        //Interrupt priority = 2 
//  NVIC->ISER[0] = 1<<GPIO5_IRQn ;                          // 
}
//=======================================================================================
// MAIN function                                                               
//---------------------------------------------------------------------------------------
static uint32_t  Adc_Vin      = ((18*437)>>7) ;            // Դѹ ADC ֵ 
static uint32_t  Adc_PCB_Temp = (1024*100/(100+470)) ;     // 25 ֵ 10K
static uint32_t  Adc_MOT_Temp = (1024*100/(100+470)) ;     // 25 ֵ 10K
static uint32_t  StopTick ;
uint32_t Count ;
int main(void)
{  
  uint32_t  CurSum , CurCnt, CurMax ;
  uint32_t  Tmr1_Tick, Tick_Add_Duty, Tick_Test_Cur ;      // ʱʼʱ  
  uint32_t  Speed=0, temp32 ;
  
  PWM_ACMP0_T0_T1_Init() ;      
  ADC->CR     = ADCR_PWM_TRG | ADCR_TRG_EN | ADCR_EN ;     //ʹADC,輸ʮ΢ȶ
  ADC->ADSAMP = 4 ;                                        // ʱ 8CLK
  ADC->ADTDCR = 0 ;                                 
                 //PWMƵ: 5_22.1KHz, 6_18.4KHz, 7_15.8KHz, 8_13.8KHz, 10_11KHz, 14_7.9K
  PWM_one_percent = 10 ;                                   // PWM  100*10,ʱ11.0592M
  PWM->CNR0       = 100*PWM_one_percent - 1 ;              //  PWM                             
  PWM->CNR1       = 100*PWM_one_percent - 1 ;              //Group, just only configue PWM01 
  Duty_Min        = 6*PWM_one_percent ;                    // ͣתռձ
  GPIO_Init() ;           // PWM,GPIO,GPIO״̬,Ϊȷֵ
  Delayus(1000);  
	
  //  BOD ѹǷΪ 2.7V ±ָλ //////////////////////////////////////////
  CLK->AHBCLK |= CLK_ISP_EN ; 
  FMC->ISPCON |= FMC_CFGUEN | FMC_EN_ ;
  FMC->ISPADR  = 0x00300000 ;                              // Config0
  FMC->ISPCMD  = FMC_READ_0 ;                              // Read config0 
  FMC->ISPTRG  = 1 ;
  while(FMC->ISPTRG & 1) ;
  temp32 = FMC->ISPDAT ;
  if((temp32 & 0x00F004C1) != 0x00200481){          
    FMC->ISPCMD  = FMC_ERASE ;   
    FMC->ISPTRG  = 1 ;
    while(FMC->ISPTRG & 1) ;
    FMC->ISPDAT  = (temp32 & 0xFF0FFF3F) | 0x00200481 ;
    FMC->ISPCMD  = FMC_WRITE ;                             //  BOD ѹд 2.7V ¸λ
    FMC->ISPTRG  = 1 ;
    while(FMC->ISPTRG & 1) ;
    GCR->IPRST_CTL1 = 1 ;                                  // Chip Reset 
  }
  FMC->ISPCON &= ~(FMC_CFGUEN | FMC_EN_) ; 
  CLK->AHBCLK &= ~CLK_ISP_EN ; 
  LOCKREG();                                               // 
  
  // ϵǷ··,  ///////////////////////////////////////////////////////
  Current_Limit = ((20*CUR_RES*1024)/5000) ;               // 20A  
  ADC->CHER     = ADC2_CURRENT ;                          
  for(temp32=0; temp32<16; ++temp32){  
    ADC->CR |= ADCR_START_BUSY ;  
    while(ADC->CR & ADCR_START_BUSY) ;  
    Current_Zero += (uint16_t)ADC->DR ; 
  }
  Current_Zero >>= 4 ;                                     // 0 ADC ֵ
  Adc_Current    = 0 ;    
  
  NVIC_SetPriority(TMR0_IRQn, 1) ;                          
  NVIC->ISER[0] = 1<<TMR0_IRQn ;	 
  SpeedLevel = *LimitSpeed ;
  if(SpeedLevel >= 2) SpeedLevel = 2 ;                     //  2 ,  2 
  *SpeedRank[SpeedLevel].LED = 1 ; 
//  temp32 = GPIO0->PIN & 0xE0 ;
//  if((temp32 == 0) || (temp32 == 0xE0)) Hall_Status |= Hall_ERR ;
                                      	
  Hall_Mode = 1 ;
  ACMP_Flag = 0 ;
  gFlag     = 0 ;                                         
  StopTick = TIMER1->DR ;              
  ADC->CR |= ADCR_START_BUSY ;                             //  ADC  
  while(1){                       
    //// ť,¶,ѹ, ==========================================================   
    temp32 = ADC->DR ;    
    if(temp32 & 0x20000){    // ADC ЧλԶ0,ADCĴ,ܱ0  
      temp32 &= 0x03FF ;     
      switch(ADC->CHER & 0xFF){ 
      case ADC2_CURRENT :	 
        if(temp32 <= Current_Zero) temp32 = 0 ;
        else temp32 -= Current_Zero ;
        Adc_Current = (Adc_Current + temp32) >> 1 ;              // ˲ʱֵ
	  
        if(((TIMER1->DR - Tick_Test_Cur) & 0xFFFFFF) > SpeedRank[SpeedLevel].Delay){ //DutyԺ
	      CurSum += Adc_Current ;                              
	      if(++CurCnt >= 16){ CurCnt = 0 ;	                     // Լ 8ms , õ16
			if(CurSum > CurMax) CurMax = CurSum ; 
            if(CurSum >= SpeedRank[SpeedLevel].CurHeavy){        //  
              gFlag |= Flag_HEANY ;                            
            }
            else if(gFlag & Flag_HEANY){ 
              if((CurMax - CurSum) >= SpeedRank[SpeedLevel].CurDrop) gFlag |= Flag_STOP ;                      
            }
            CurSum = 0 ;	 
          }
        }
		else{ CurSum = 0; 	CurCnt = 0;  }
	        
        ADC->CHER = ADC1_VIN ;                       
        break ;     
      
      case ADC1_VIN : 
        Adc_Vin = (Adc_Vin + temp32) >> 1 ; 		
        if((Adc_Vin < VIN_MIN_L) && (Adc_Vin > (VIN_MIN_L >> 1)))gFlag |=  Flag_VOLTAGE_LOW ;  
        else                     gFlag &= ~Flag_VOLTAGE_LOW ; 
                   
        ADC->CHER = ADC3_SPEED ;                             
        break ; 
      
      case ADC3_SPEED : 
		Speed  = (Speed + temp32) >> 1 ;  
        temp32 = ((Speed * 11) >> 3) ;	
        if(temp32 < 750) Tick_Test_Cur = TIMER1->DR ;  	  
        temp32 = ((temp32 * SpeedRank[SpeedLevel].Duty) >> 7) ;	
        if(temp32 < Duty_Min){
          temp32 = 0 ;
          gFlag &= ~(Flag_HEANY | Flag_STOP) ;             // ط,ر־
        }
        Duty_Command = temp32 ;          
        Duty_Target  = Duty_Command ;	  	

        ADC->CHER = ADC0_MOTOR_TEMP ;                             
        break ; 
      
      case ADC0_MOTOR_TEMP :
        Adc_MOT_Temp = (Adc_MOT_Temp + temp32) >> 1 ;
        if(Adc_MOT_Temp < TEMP_MOT_H) gFlag |= Flag_MOT_TEMP_OV ;
        else  gFlag &= ~Flag_MOT_TEMP_OV ;  
          
        ADC->CHER = ADC7_PCB_TEMP ;                             
        break ; 
      
      case ADC7_PCB_TEMP :
        Adc_PCB_Temp = (Adc_PCB_Temp + temp32) >> 1 ;
        if(Adc_PCB_Temp < TEMP_PCB_H) gFlag |= Flag_PCB_TEMP_OV ;
        else  gFlag &= ~Flag_PCB_TEMP_OV ;  
      
      default :                                                      
        ADC->CHER = ADC2_CURRENT ;                                 
      }                       
    }
    
    /////////////////////////////////////////////////////////////////////////////////////   
    if((gFlag & Flag_STOP) && ((gFlag & Flag_REVERSE) == 0)) Duty_Target = 0 ;	  
    if(Adc_Vin >= VIN_MIN_LL) Tmr1_Tick = TIMER1->DR ;           // ѹʱ	
    else{   
      if(((TIMER1->DR - Tmr1_Tick)&0xFFFFFF) > 2000*1000){       // ѹͳ 2 , ͣ 
        Duty_Target = 0 ;  
      }
      if(((TIMER1->DR - StopTick)&0xFFFFFF) > 9000*1000) GPIO01 = 0; // ͣת9,ػ    
    }
    if(Adc_PCB_Temp < TEMP_PCB_HH) Duty_Target = 0 ;             // ¶̫, ͣת
    if(Adc_MOT_Temp < TEMP_MOT_HH) Duty_Target = 0 ;    
  
    ///////////  ////////////////////////////////////////////////////////////////  		
      if(Duty_Current == 0){                                     // ѹΪ 0	
        if(Duty_Target >= Duty_Min + PWM_one_percent){
          if((gFlag & (Flag_PCB_TEMP_OV | Flag_MOT_TEMP_OV | Flag_VOLTAGE_LOW)) == 0){ 
            if((GPIO00 == 0) || (GPIO54 == 0)){           
              BLDC_STOP() ;  
              Delayus(200) ;  
              BLDC_Hall_Init() ;                                 // Hall ʼ 
              pPhaseStart = &TabPhase[0] ;                       // HallתʹԱpPhaseStart+1 ~ pPhaseStart+6  
              pPhaseCur   = &TabPhase[0] ;                     
              pTimer      = &TIMER1->DR ;                        // ʱĶʱ, ģʽ
              PeriodHall  = 100*1000 ;   
              pPhase      = &TabPhase[1] ; Motor_Beep(1000,600) ; // ÷, õЩֵ
              ++pPhase ;  Motor_Beep(1000,600) ;  
              ++pPhase ;  Motor_Beep(1000,600) ; 
              Duty_Current  = Duty_Min ;                         // תռձ              
              NVIC->ISPR[0] = 1<<GPIO01_IRQn ;		
              NVIC->ISER[0] = 1<<GPIO01_IRQn ;		             //  Hall ж
              Tick_Add_Duty = TIMER1->DR ;   
              gFlag        |= Flag_BRAKE ; 
              CurSum = 0;    CurCnt = 0;   CurMax = 0;
              GPIO01 = 1;			
              LED_LIGHT() ;        
            }
          }
        }
        else{
          if(gFlag & Flag_BRAKE){                                // ûɲ
            BLDC_Brake() ;                                       // ɲ
            gFlag &= ~Flag_BRAKE ; 
            gFlag |=  Flag_BRAKE_ING ;  
            NVIC->ICER[0] = 1<<GPIO01_IRQn ;	                
            HallTick = TIMER1->DR ;
          }
          else{
            if(gFlag & Flag_BRAKE_ING){
              if(((TIMER1->DR - HallTick)&0xFFFFFF) > 1000*1000){
                BLDC_STOP();                                     // ƶ				  
              }
            }
          }
             
          if(GPIO00 == 0)      gFlag &= ~Flag_REVERSE ;          // ͣתʱ, ſԸıת
          else if(GPIO54 == 0) gFlag |= Flag_REVERSE ;  
         
          if(SpeedLevel != *LimitSpeed){    
            UnlockReg(); 
              CLK->AHBCLK |= CLK_ISP_EN ; 
              FMC->ISPCON |= FMC_LDUEN | FMC_EN_  ;
              FMC->ISPADR  = (uint32_t)LimitSpeed ;                         
              FMC->ISPCMD  = FMC_ERASE ;                         // Read config0 
              FMC->ISPTRG  = 1 ;
              while(FMC->ISPTRG & 1) ; 
              FMC->ISPDAT  = SpeedLevel ;
              FMC->ISPCMD  = FMC_WRITE ;   
              FMC->ISPTRG  = 1 ;
              while(FMC->ISPTRG & 1) ;
            LOCKREG(); 
            SpeedLevel = *LimitSpeed ;			  
          }  
        }
      }
      else{                                                      // ת״̬
        StopTick = TIMER1->DR ;   
        if(Duty_Target <= Duty_Current) Duty_Current = Duty_Target ;          
        else{
          if(StepCount < 8) temp32 = 1*1000;
          else temp32 = 300 ;            
          if(((TIMER1->DR - Tick_Add_Duty) & 0xFFFFFF) >= temp32){                  
            Tick_Add_Duty = TIMER1->DR ;  
            ++Duty_Current ; 
          }            
        }	
      }
    ////===== Ŵ ==============================================================
  }    
}

void SysTick_Handler(void)                                       // 20ms жһ
{	
  uint32_t static LED_Data = 0, LED_Flash = 0 ;
  uint32_t static Key, Key_Doul = 0 ;
	
  --TickRelay ; 
#if 1
  if(Duty_Command >= Duty_Min){        
    if(gFlag & (Flag_PCB_TEMP_OV | Flag_MOT_TEMP_OV)){        // , 	
      if(LED_Data != 0x90){ LED_Data = 0x90;  LED_Flash = 0x90; }
    } 
    else if(gFlag & Flag_VOLTAGE_LOW){                             // ѹ,һ   
      if(LED_Data != 0x10){ LED_Data = 0x10; LED_Flash = 0x10; }
    }
    else{ LED_Data = 0;  LED_Flash = 0; }
  }
  else{ LED_Data = 0;  LED_Flash = 0; }
  
  if(LED_Data){
    LED_Flash >>= 1 ;
    if(LED_Flash & 1){ LED_Flash |= 0x80000000;  LED_LIGHT();  }
    else LED_DARK() ;
  }
  else if((GPIO00 == 0) || (GPIO54 == 0)) LED_LIGHT();           // ת򿪹ؽӴLED
  else LED_DARK() ;
#endif 
  
  if(Key == (GPIO5->PIN & 0x20)){
    if(Key) Key_Doul = 0 ;
    else if (Key_Doul == 0){ 
      if(++SpeedLevel > 2) SpeedLevel = 0 ;                  // 
      LED1_DARK() ;	LED2_DARK() ;  LED3_DARK() ;  
      *SpeedRank[SpeedLevel].LED = 1 ;
      StopTick = TIMER1->DR ;  
      Key_Doul = 1 ;
    }
  }
  Key = GPIO5->PIN & 0x20 ;
}
